Index: trunk/modelicaml/kepler/org.openmodelica.modelicaml.view.valuebindings/src/org/openmodelica/modelicaml/view/valuebindings/model/TreeBuilder.java
===================================================================
--- trunk/modelicaml/kepler/org.openmodelica.modelicaml.view.valuebindings/src/org/openmodelica/modelicaml/view/valuebindings/model/TreeBuilder.java	(revision 1796)
+++ trunk/modelicaml/kepler/org.openmodelica.modelicaml.view.valuebindings/src/org/openmodelica/modelicaml/view/valuebindings/model/TreeBuilder.java	(revision 1797)
@@ -55,4 +55,5 @@
 import org.openmodelica.modelicaml.common.constants.Constants;
 import org.openmodelica.modelicaml.common.services.ModelicaMLServices;
+import org.openmodelica.modelicaml.common.valuebindings.helpers.BindingsData;
 import org.openmodelica.modelicaml.common.valuebindings.helpers.BindingsDataCollector;
 import org.openmodelica.modelicaml.common.valuebindings.helpers.MediatorsCollector;
@@ -582,4 +583,13 @@
 	
 	private void sortData(){
+		
+		// clear the data in the common service in order to 
+		BindingsData.clearAll();
+		
+		// collect data to pass to the common service for other views
+		HashSet<Element> clients = new HashSet<Element>();
+		HashSet<Element> clientsMandatory = new HashSet<Element>();
+		HashSet<Element> providers = new HashSet<Element>();
+		
 		for (Element valueMediator : valueMediators) {
 			if (valueMediator instanceof Property) {
@@ -593,4 +603,7 @@
 							// add items to the overall map 
 							addToMapList(valueMediatorToValueProviders, valueMediator, element);
+							
+							// collect to pass to the common service							
+							providers.add(element);
 						}
 					}
@@ -601,4 +614,8 @@
 							// add items to the overall map 
 							addToMapList(valueMediatorToValueClients, valueMediator, element);
+							
+							// collect to pass to the common service
+							clients.add(element);
+							clientsMandatory.addAll(getRequiredValueClients(valueMediator));
 						}
 					}
@@ -606,4 +623,8 @@
 			}
 		}
+		
+		// pass collected bindings data to the common service so that other views can use it
+		BindingsData.setBindingsData(clients, clientsMandatory, providers, valueMediators);
+
 	}
 	
Index: trunk/modelicaml/kepler/org.openmodelica.modelicaml.view.valuebindings/src/org/openmodelica/modelicaml/view/valuebindings/model/TreeUtls.java
===================================================================
--- trunk/modelicaml/kepler/org.openmodelica.modelicaml.view.valuebindings/src/org/openmodelica/modelicaml/view/valuebindings/model/TreeUtls.java	(revision 1796)
+++ trunk/modelicaml/kepler/org.openmodelica.modelicaml.view.valuebindings/src/org/openmodelica/modelicaml/view/valuebindings/model/TreeUtls.java	(revision 1797)
@@ -256,8 +256,10 @@
 		
 		if ( mode == Constants.MODE_ADD_CLIENT ) {
-			return "Provides value for: ";
+//			return "Provides value for: ";
+			return "Mediator to client: ";
 		}
 		else if (mode == Constants.MODE_ADD_PROVIDER ) {
-			return "Obtains value from: ";
+//			return "Obtains value from: ";
+			return "Mediator to provider: ";
 		}
 		return null;
Index: trunk/modelicaml/kepler/org.openmodelica.modelicaml.view.valuebindings/src/org/openmodelica/modelicaml/view/valuebindings/sections/PropertySection_ClientOperationEditor.java
===================================================================
--- trunk/modelicaml/kepler/org.openmodelica.modelicaml.view.valuebindings/src/org/openmodelica/modelicaml/view/valuebindings/sections/PropertySection_ClientOperationEditor.java	(revision 1796)
+++ trunk/modelicaml/kepler/org.openmodelica.modelicaml.view.valuebindings/src/org/openmodelica/modelicaml/view/valuebindings/sections/PropertySection_ClientOperationEditor.java	(revision 1797)
@@ -44,8 +44,4 @@
 import org.eclipse.jface.viewers.ISelection;
 import org.eclipse.jface.viewers.IStructuredSelection;
-import org.eclipse.papyrus.infra.core.services.ServiceException;
-import org.eclipse.papyrus.infra.core.services.ServicesRegistry;
-import org.eclipse.papyrus.infra.core.utils.ServiceUtils;
-import org.eclipse.papyrus.infra.core.utils.ServiceUtilsForActionHandlers;
 import org.eclipse.swt.SWT;
 import org.eclipse.swt.events.ModifyEvent;
@@ -66,4 +62,5 @@
 import org.openmodelica.modelicaml.common.constants.Constants;
 import org.openmodelica.modelicaml.common.contentassist.ModelicaMLContentAssist;
+import org.openmodelica.modelicaml.common.services.EditorServices;
 import org.openmodelica.modelicaml.common.services.StringUtls;
 import org.openmodelica.modelicaml.common.validation.services.ModelicaMLMarkerSupport;
@@ -191,13 +188,8 @@
 		// Get Papyrus editing domain
 //		editingDomain = EditorUtils.getTransactionalEditingDomain();
-		ServicesRegistry serviceRegistry;
-		try {
-			serviceRegistry = ServiceUtilsForActionHandlers.getInstance().getServiceRegistry();
-			editingDomain = ServiceUtils.getInstance().getTransactionalEditingDomain(serviceRegistry);
-
-		} catch (ServiceException e) {
-			// TODO Auto-generated catch block
-			e.printStackTrace();
-		}
+//		ServicesRegistry serviceRegistry;
+//			serviceRegistry = ServiceUtilsForActionHandlers.getInstance().getServiceRegistry();
+//			editingDomain = ServiceUtils.getInstance().getTransactionalEditingDomain(serviceRegistry);
+		editingDomain = EditorServices.getPapyrusEditingDomain();
 		
 	}
Index: trunk/modelicaml/kepler/org.openmodelica.modelicaml.view.valuebindings/src/org/openmodelica/modelicaml/view/valuebindings/sections/PropertySection_Details.java
===================================================================
--- trunk/modelicaml/kepler/org.openmodelica.modelicaml.view.valuebindings/src/org/openmodelica/modelicaml/view/valuebindings/sections/PropertySection_Details.java	(revision 1796)
+++ trunk/modelicaml/kepler/org.openmodelica.modelicaml.view.valuebindings/src/org/openmodelica/modelicaml/view/valuebindings/sections/PropertySection_Details.java	(revision 1797)
@@ -48,8 +48,4 @@
 import org.eclipse.jface.viewers.IStructuredSelection;
 import org.eclipse.jface.viewers.TreeViewer;
-import org.eclipse.papyrus.infra.core.services.ServiceException;
-import org.eclipse.papyrus.infra.core.services.ServicesRegistry;
-import org.eclipse.papyrus.infra.core.utils.ServiceUtils;
-import org.eclipse.papyrus.infra.core.utils.ServiceUtilsForActionHandlers;
 import org.eclipse.papyrus.views.modelexplorer.ModelExplorerPageBookView;
 import org.eclipse.papyrus.views.modelexplorer.ModelExplorerView;
@@ -81,4 +77,5 @@
 import org.eclipse.uml2.uml.Stereotype;
 import org.openmodelica.modelicaml.common.constants.Constants;
+import org.openmodelica.modelicaml.common.services.EditorServices;
 import org.openmodelica.modelicaml.common.utls.SWTResourceManager;
 import org.openmodelica.modelicaml.view.valuebindings.model.TreeObject;
@@ -302,15 +299,10 @@
 		//########## storing start
 //		TransactionalEditingDomain editingDomain = EditorUtils.getTransactionalEditingDomain();
-		ServicesRegistry serviceRegistry;
-		TransactionalEditingDomain editingDomain = null;
-
-		try {
-			serviceRegistry = ServiceUtilsForActionHandlers.getInstance().getServiceRegistry();
-			editingDomain = ServiceUtils.getInstance().getTransactionalEditingDomain(serviceRegistry);
-
-		} catch (ServiceException e) {
-			// TODO Auto-generated catch block
-			e.printStackTrace();
-		}
+//		ServicesRegistry serviceRegistry;
+//		TransactionalEditingDomain editingDomain = null;
+
+//			serviceRegistry = ServiceUtilsForActionHandlers.getInstance().getServiceRegistry();
+//			editingDomain = ServiceUtils.getInstance().getTransactionalEditingDomain(serviceRegistry);
+		TransactionalEditingDomain editingDomain = EditorServices.getPapyrusEditingDomain();
 
 		CompoundCommand cc = new CompoundCommand();
@@ -359,15 +351,10 @@
 			//########## storing start
 //			TransactionalEditingDomain editingDomain = EditorUtils.getTransactionalEditingDomain();
-			ServicesRegistry serviceRegistry;
-			TransactionalEditingDomain editingDomain = null;
-
-			try {
-				serviceRegistry = ServiceUtilsForActionHandlers.getInstance().getServiceRegistry();
-				editingDomain = ServiceUtils.getInstance().getTransactionalEditingDomain(serviceRegistry);
-
-			} catch (ServiceException e) {
-				// TODO Auto-generated catch block
-				e.printStackTrace();
-			}
+//			ServicesRegistry serviceRegistry;
+//			TransactionalEditingDomain editingDomain = null;
+
+//				serviceRegistry = ServiceUtilsForActionHandlers.getInstance().getServiceRegistry();
+//				editingDomain = ServiceUtils.getInstance().getTransactionalEditingDomain(serviceRegistry);
+			TransactionalEditingDomain editingDomain = EditorServices.getPapyrusEditingDomain();
 			
 			CompoundCommand cc = new CompoundCommand();
Index: trunk/modelicaml/kepler/org.openmodelica.modelicaml.view.valuebindings/src/org/openmodelica/modelicaml/view/valuebindings/sections/PropertySection_MediatorOperationEditor.java
===================================================================
--- trunk/modelicaml/kepler/org.openmodelica.modelicaml.view.valuebindings/src/org/openmodelica/modelicaml/view/valuebindings/sections/PropertySection_MediatorOperationEditor.java	(revision 1796)
+++ trunk/modelicaml/kepler/org.openmodelica.modelicaml.view.valuebindings/src/org/openmodelica/modelicaml/view/valuebindings/sections/PropertySection_MediatorOperationEditor.java	(revision 1797)
@@ -42,8 +42,4 @@
 import org.eclipse.jface.viewers.ISelection;
 import org.eclipse.jface.viewers.IStructuredSelection;
-import org.eclipse.papyrus.infra.core.services.ServiceException;
-import org.eclipse.papyrus.infra.core.services.ServicesRegistry;
-import org.eclipse.papyrus.infra.core.utils.ServiceUtils;
-import org.eclipse.papyrus.infra.core.utils.ServiceUtilsForActionHandlers;
 import org.eclipse.papyrus.infra.emf.utils.BusinessModelResolver;
 import org.eclipse.swt.SWT;
@@ -62,8 +58,8 @@
 import org.openmodelica.modelicaml.common.constants.Constants;
 import org.openmodelica.modelicaml.common.contentassist.ModelicaMLContentAssist;
+import org.openmodelica.modelicaml.common.services.EditorServices;
 import org.openmodelica.modelicaml.common.validation.services.ModelicaMLMarkerSupport;
 import org.openmodelica.modelicaml.editor.xtext.valuebinding.ui.internal.MediatorActivator;
 import org.openmodelica.modelicaml.tabbedproperties.editors.glue.edit.part.PropertiesSectionXtextEditorHelper;
-import org.openmodelica.modelicaml.view.valuebindings.model.TreeObject;
 
 import com.google.inject.Injector;
@@ -73,5 +69,5 @@
 	
 //	private Link textOperation;
-	private TreeObject item = null;
+//	private TreeObject item = null;
 	
 	
@@ -104,5 +100,5 @@
 	
 	/** The owning class. */
-	private Element owningClass;
+//	private Element owningClass;
 	
 	/** The is new selection. */
@@ -162,13 +158,8 @@
 		// Get Papyrus editing domain
 //		editingDomain = EditorUtils.getTransactionalEditingDomain();
-		ServicesRegistry serviceRegistry;
-		try {
-			serviceRegistry = ServiceUtilsForActionHandlers.getInstance().getServiceRegistry();
-			editingDomain = ServiceUtils.getInstance().getTransactionalEditingDomain(serviceRegistry);
-
-		} catch (ServiceException e) {
-			// TODO Auto-generated catch block
-			e.printStackTrace();
-		}
+//		ServicesRegistry serviceRegistry;
+//			serviceRegistry = ServiceUtilsForActionHandlers.getInstance().getServiceRegistry();
+//			editingDomain = ServiceUtils.getInstance().getTransactionalEditingDomain(serviceRegistry);
+		editingDomain = EditorServices.getPapyrusEditingDomain();
 	}
 
Index: trunk/modelicaml/kepler/org.openmodelica.modelicaml.view.valuebindings/src/org/openmodelica/modelicaml/view/valuebindings/sections/PropertySection_ProviderOperationEditor.java
===================================================================
--- trunk/modelicaml/kepler/org.openmodelica.modelicaml.view.valuebindings/src/org/openmodelica/modelicaml/view/valuebindings/sections/PropertySection_ProviderOperationEditor.java	(revision 1796)
+++ trunk/modelicaml/kepler/org.openmodelica.modelicaml.view.valuebindings/src/org/openmodelica/modelicaml/view/valuebindings/sections/PropertySection_ProviderOperationEditor.java	(revision 1797)
@@ -44,8 +44,4 @@
 import org.eclipse.jface.viewers.ISelection;
 import org.eclipse.jface.viewers.IStructuredSelection;
-import org.eclipse.papyrus.infra.core.services.ServiceException;
-import org.eclipse.papyrus.infra.core.services.ServicesRegistry;
-import org.eclipse.papyrus.infra.core.utils.ServiceUtils;
-import org.eclipse.papyrus.infra.core.utils.ServiceUtilsForActionHandlers;
 import org.eclipse.swt.SWT;
 import org.eclipse.swt.events.ModifyEvent;
@@ -66,4 +62,5 @@
 import org.openmodelica.modelicaml.common.constants.Constants;
 import org.openmodelica.modelicaml.common.contentassist.ModelicaMLContentAssist;
+import org.openmodelica.modelicaml.common.services.EditorServices;
 import org.openmodelica.modelicaml.common.services.StringUtls;
 import org.openmodelica.modelicaml.common.validation.services.ModelicaMLMarkerSupport;
@@ -189,15 +186,7 @@
 		});
 		
-		// Get Papyrus editing domain
-//		editingDomain = EditorUtils.getTransactionalEditingDomain();
-		ServicesRegistry serviceRegistry;
-		try {
-			serviceRegistry = ServiceUtilsForActionHandlers.getInstance().getServiceRegistry();
-			editingDomain = ServiceUtils.getInstance().getTransactionalEditingDomain(serviceRegistry);
-
-		} catch (ServiceException e) {
-			// TODO Auto-generated catch block
-			e.printStackTrace();
-		}
+//			serviceRegistry = ServiceUtilsForActionHandlers.getInstance().getServiceRegistry();
+//			editingDomain = ServiceUtils.getInstance().getTransactionalEditingDomain(serviceRegistry);
+		editingDomain = EditorServices.getPapyrusEditingDomain();
 	}
 	