Index: trunk/org.modelica.mdt.debug.core/.settings/org.eclipse.jdt.core.prefs
===================================================================
--- trunk/org.modelica.mdt.debug.core/.settings/org.eclipse.jdt.core.prefs	(revision 1891)
+++ trunk/org.modelica.mdt.debug.core/.settings/org.eclipse.jdt.core.prefs	(revision 1892)
@@ -9,3 +9,4 @@
 org.eclipse.jdt.core.compiler.problem.assertIdentifier=error
 org.eclipse.jdt.core.compiler.problem.enumIdentifier=error
+org.eclipse.jdt.core.compiler.release=enabled
 org.eclipse.jdt.core.compiler.source=1.6
Index: trunk/org.modelica.mdt.debug.core/META-INF/MANIFEST.MF
===================================================================
--- trunk/org.modelica.mdt.debug.core/META-INF/MANIFEST.MF	(revision 1891)
+++ trunk/org.modelica.mdt.debug.core/META-INF/MANIFEST.MF	(revision 1892)
@@ -26,5 +26,9 @@
  org.modelica.mdt.debug.gdb.core.model.stack,
  org.modelica.mdt.debug.gdb.core.model.thread,
- org.modelica.mdt.debug.gdb.core.sourcelookup
+ org.modelica.mdt.debug.gdb.core.model.value,
+ org.modelica.mdt.debug.gdb.core.model.variable,
+ org.modelica.mdt.debug.gdb.core.sourcelookup,
+ org.modelica.mdt.debug.gdb.helper
 Bundle-ActivationPolicy: lazy
 Bundle-RequiredExecutionEnvironment: JavaSE-1.6
+Automatic-Module-Name: org.modelica.mdt.debug.core
Index: trunk/org.modelica.mdt.debug.core/src/org/modelica/mdt/debug/core/breakpoints/MDTExceptionBreakpoint.java
===================================================================
--- trunk/org.modelica.mdt.debug.core/src/org/modelica/mdt/debug/core/breakpoints/MDTExceptionBreakpoint.java	(revision 1891)
+++ trunk/org.modelica.mdt.debug.core/src/org/modelica/mdt/debug/core/breakpoints/MDTExceptionBreakpoint.java	(revision 1892)
@@ -327,5 +327,5 @@
 	 */
 	protected String[] parseList(String listString) {
-		List list = new ArrayList(10);
+		List<String> list = (List<String>)new ArrayList<String>(10);
 		StringTokenizer tokenizer = new StringTokenizer(listString, ","); //$NON-NLS-1$
 		while (tokenizer.hasMoreTokens()) {
Index: trunk/org.modelica.mdt.debug.core/src/org/modelica/mdt/debug/core/launcher/MDTLaunchDelegate.java
===================================================================
--- trunk/org.modelica.mdt.debug.core/src/org/modelica/mdt/debug/core/launcher/MDTLaunchDelegate.java	(revision 1891)
+++ trunk/org.modelica.mdt.debug.core/src/org/modelica/mdt/debug/core/launcher/MDTLaunchDelegate.java	(revision 1892)
@@ -66,5 +66,5 @@
 		if (mode.equals(ILaunchManager.DEBUG_MODE)) 
 		{						
-			List commandList = new ArrayList();
+			List<String> commandList = (List<String>)new ArrayList<String>();
 			//configuration.
 			commandList.add(debugTargetProgram);
Index: trunk/org.modelica.mdt.debug.core/src/org/modelica/mdt/debug/core/model/MDTVariable.java
===================================================================
--- trunk/org.modelica.mdt.debug.core/src/org/modelica/mdt/debug/core/model/MDTVariable.java	(revision 1891)
+++ trunk/org.modelica.mdt.debug.core/src/org/modelica/mdt/debug/core/model/MDTVariable.java	(revision 1892)
@@ -127,5 +127,5 @@
 	public IValue buildMDTValue(DefaultMutableTreeNode root)
 	{
-		Enumeration kids = root.children();		
+		Enumeration kids = root.children();
 		ModelicaVariableInfo vi = (ModelicaVariableInfo)root.getUserObject();
 		String value = vi.toString();		
Index: trunk/org.modelica.mdt.debug.core/src/org/modelica/mdt/debug/gdb/core/mi/RxThread.java
===================================================================
--- trunk/org.modelica.mdt.debug.core/src/org/modelica/mdt/debug/gdb/core/mi/RxThread.java	(revision 1891)
+++ trunk/org.modelica.mdt.debug.core/src/org/modelica/mdt/debug/gdb/core/mi/RxThread.java	(revision 1892)
@@ -104,5 +104,6 @@
 				setPrompt(line);
 				List<String> outputs = filterMIOutput(line + "\n");
-				for (String output : outputs) {
+				String[] outputsArray = (String[]) outputs.toArray(); 
+				for (String output : outputsArray) {
 					processMIOutput(output + "\n");
 					// logging
@@ -152,5 +153,5 @@
 			return createMIOutputArray(buffer, "*"+MIAsyncRecord.STOPPED+",");
 		} else {
-			List<String> outputs = new ArrayList<String>();
+			List<String> outputs = (List<String>)new ArrayList<String>();
 			outputs.add(buffer);
 			return outputs;
@@ -166,5 +167,5 @@
 	private List<String> createMIOutputArray(String buffer, String separator) {
 		// TODO Auto-generated method stub
-		List<String> outputs = new ArrayList<String>();
+		List<String> outputs = (List<String>)new ArrayList<String>();
 		outputs.add(buffer.substring(0, buffer.indexOf(separator)));
 		outputs.add(buffer.substring(buffer.indexOf(separator)));
@@ -550,5 +551,5 @@
 
 	String[] getStreamRecords() {
-		List<String> streamRecords = new ArrayList<String>(fStreamRecords.size());
+		List<String> streamRecords = (List<String>)new ArrayList<String>(fStreamRecords.size());
 		for (MIStreamRecord rec : fStreamRecords) {
 			String str = rec.getString().trim();
Index: trunk/org.modelica.mdt.debug.core/src/org/modelica/mdt/debug/gdb/helper/ValueHelper.java
===================================================================
--- trunk/org.modelica.mdt.debug.core/src/org/modelica/mdt/debug/gdb/helper/ValueHelper.java	(revision 1891)
+++ trunk/org.modelica.mdt.debug.core/src/org/modelica/mdt/debug/gdb/helper/ValueHelper.java	(revision 1892)
@@ -362,10 +362,10 @@
 			arrayIndexes.get(0);
 		
-		int index = 0;
-		for(int i = 0 ; i < arrayIndexes.size() - 1 ; i++)
+		int index = 0, size = arrayIndexes.size();
+		for(int i = 0 ; i < size - 1 ; i++)
 		{
 			index += getArrayIndexHelper(itemName, i, arrayIndexes, gdbStackFrame);
 		}
-		index += arrayIndexes.get(arrayIndexes.size() - 1);
+		index += arrayIndexes.get(size - 1);
 		return index;
 	}